
/*  jQuery.ma.mapa  v1.0  */
(function ($) {
    $.widget('ui.mapaMA', (function () {
        var directionsService = new google.maps.DirectionsService();
        var map;
        var marcadores_activos = [];
        var self;
        var limites = new google.maps.LatLngBounds();
        var infowindow;
        var caminho = [];
        return {
            options: {
                mapa: true,
                direccoes: true,
                imprimir: true,
                altura: '100',
				lat: 0,
				lng: 0,
                largura: '100',
                percentagem: false,
                enableControls: true,
                directionsboxID: 'directionsboxMA',
                directionsID: 'directionsMA',
                imgFolder: '/images/mapa',
                pinsDiferentes: true,
                abrePopups: true,
				pinCenterPosition: [0,0],
                textos: {
                    procurar: 'Local onde se encontra',
                    origem: 'Origem',
                    destino: 'Destino',
                    botao: 'Procurar',
                    definirdestino: 'Definir como destino',
                    naoencontrou: 'N&atilde;o foram encontrados caminhos',
                    infoTrajecto: '',
                    distancia: 'Dist&acirc;cia',
                    duracao: 'Tempo'
                },
                rotaOptions: {
                    corlinha: '#2A4C43'
                },
                mapOptions: {
                    //center: new google.maps.LatLng(lat,lng),
                    zoom: 13,
                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                    mapTypeControl: true,
                    mapTypeControlOptions: {},
                    panControl: true,
                    panControlOptions: {},
                    zoomControl: true,
                    zoomControlOptions: {},
                    streetViewControl: false,
                    scrollwheel: true,
                    disableDefaultUI: false,
                    minZoom: 5,
                    maxZoom: 15
                },
                marcadores: []
            },
            /* ------ CRIA MAPA -----------------------------------------------------------------------------------------*/
            _create: function () {
                self = this;
				
                infowindow = new google.maps.InfoWindow();

                if (self.options.mapa) {
                    $(this.element[0]).append('<div id="mapaMA"></div>')
                    //define o tamanho do componente todo
                    this.element.css("width", this.options.largura);
                    this.element.height("100%");

                    //define o tamanho do mapa
                    $("#mapaMA").css("height", this.options.altura);
                    $("#mapaMA").width("100%");

                    //inicia o mapa
                    map = new google.maps.Map($("#mapaMA")[0], this.options.mapOptions);
                    map.setCenter(new google.maps.LatLng(this.options.lat, this.options.lng));

                }
                if (self.options.direccoes) {
                    if (this.options.enableControls) this._createControls();
                }
				if (this.options.marcadores.length > 0) this._criaMarcadores();
				
            },
            _createControls: function () {

                if (this.options.directionsboxID == 'directionsboxMA') {
                    $(this.element[0]).append('<div id="directionsboxMA"></div>')
                }

                if (this.options.directionsID == 'directionsMA') {
                    $(this.element[0]).append('<div id="directionsMA"></div>')
                }

                $("#" + this.options.directionsboxID + "").append('<div id="directions-sel-MA"></div>');
                $("#directions-sel-MA").append('<div id="origem-mapa-MA"><input id="origemMAPA" class="input-map-MA input" type="text" placeholder="' + self.options.textos.procurar + '" name="origem"></div>');

                if (self.options.marcadores.length > 1) { $("#directions-sel-MA").append('<div id="destino-mapa-MA"><select id="destinoMAPA"></select></div>') };

                $("#directions-sel-MA").append('<div id="botao-mapa-MA" style="cursor:pointer; cursro:hand;">' + self.options.textos.botao + '</div>');

                $("#botao-mapa-MA").click(function () {
                    if ($("#origemMAPA").val() != "" || $("#origemMAPA").val() != self.options.textos.procurar)
                        self._criaRota();
                });

                $("#origemMAPA").keypress(function (e) {
                    if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
                        $("#botao-mapa-MA").click();
                        return false;
                    } else {
                        return true;
                    }
                });

                if (self.options.imprimir) {
                    $(document).on("click","#options-mapa-print-MA", function () {
                        var mywindow = window.open('', 'PrintRota', 'height=600,width=540,scrollbars=1,location=0,status=0,menubar=0');
                        mywindow.document.write('<html><head><title>Print Directions</title>');
                        mywindow.document.write('<link rel="stylesheet" href="/css/jquery.ma.mapa.simple.css" type="text/css" />');
                        mywindow.document.write('<style>body{font-size:11px; font-family:arial} #options-mapa-print-MA,#options-mapa-close-MA{display:none!important}</style>');
                        mywindow.document.write('</head><body><a onclick="print();"><img src="/images/mapa/imprimir.png" /></a>');
                        mywindow.document.write($("#" + self.options.directionsID).html());
                        mywindow.document.write('</body></html>');
                        mywindow.document.close();
                        mywindow.print();
                    });
                }
				$(document).on("click","#options-mapa-close-MA",function () {
				
				
                    self._reset();
                    self._criaMarcadores();
                });

				openPop= function (val){
					$("#destinoMAPA").val(val);
				}
            },
            _reset: function () {
                for (var h = marcadores_activos.length - 1; h >= 0; h--) {
                    marcadores_activos[h].marker.setMap(null);
                }
                $(".pto_check").attr('checked', false);
                $(".control_check").css('background-position', "top");

                self.apagaRota();
                marcadores_activos = [];
                limites = new google.maps.LatLngBounds();

                $("#options-mapa-close-MA").hide();
                $("#options-mapa-print-MA").hide();
                $("#dir_erro").hide();
            },
            /*-----   INICIO DAS FUNCOES DOS MARCADORES     --------------------------------------------------------------*/
            _criaMarcadores: function () {
                self = this;
                var op = "";

                for (var i = 0; i < this.options.marcadores.length; i++) {
					var marcador = self.options.marcadores[i];
					if(marcador.id) {
						self._adicionaMarcador(marcador);
						op += '<option value="' + marcador.id + '">' + marcador.titulo + '</option>';
					}
                }
                if (self.options.mapa) {
                    if (this.options.marcadores.length == 1) { map.panTo(new google.maps.LatLng(self.options.marcadores[0].lat, self.options.marcadores[0].lng)) } else { map.fitBounds(limites); };
                }
                if (this.options.marcadores.length > 1) $("#destinoMAPA").html(op);

            },
            //ADICIONA UM DETERMINADO MARCADOR
            _adicionaMarcador: function (marcador) {
                var marker = this._constroiMarcador(new google.maps.LatLng(marcador.lat, marcador.lng), marcador.titulo, marcador.id)
                if (this.options.abrePopups)
                    this.adicionaListenerMarcador(marker, marcador);
            },
            //CONSTROI O MARCADOR
            _constroiMarcador: function (point, titulo, id) {
                var pin = this.getPinImg(id);
                marker = new google.maps.Marker({
                    position: point,
                    icon: pin,
                    map: map,
					clickable:this.options.abrePopups,
                    title: titulo
                });
                limites.extend(marker.getPosition());
				marcadores_activos.push({ "id": id,"marker": marker});
                return marker;
            },
            getPinImg: function (id) {
                if (!self.options.pinsDiferentes && id) id = 0;
                if (id == undefined) id = "origem";
				if(this.options.pinCenterPosition[0]>0){
					return new google.maps.MarkerImage(this.options.imgFolder + '/pin_' + id + '.png', null, null, new google.maps.Point(this.options.pinCenterPosition[0], this.options.pinCenterPosition[1]));
				}else{
					return new google.maps.MarkerImage(this.options.imgFolder + '/pin_' + id + '.png');
				}
            },
            /* ADICIONA OS LISTENERS A CADA MARKER */
            adicionaListenerMarcador: function (marker, marcador) {

                google.maps.event.addListener(marker, 'click', (function (marker, marcador) {
                    return function () {
                        infowindow.close();
                        frame = '<div id="popup-mapa-MA">' + marcador.conteudo + '</div>';

                        if (self.options.marcadores.length > 1)
                            frame += '<p id="clicapop" value="' + marcador.id + '" onclick=openPop('+marcador.id +')>' + self.options.textos.definirdestino + '  <img src="/images/mapa/pin_0.png" alt="" width="12px" height="16px" style="border:0px;vertical-align:middle;padding-bottom:3px;" /></p>';

                        infowindow.setContent(frame);
                        infowindow.open(map, this);
                    }
                })(marker, marcador));
            },

            /*-----   INICIO DAS FUNCOES DAS ROTAS     --------------------------------------------------------------------*/

            _criaRota: function () {

                var origem = $("#origemMAPA").val();

                if (self.options.marcadores.length > 1) {

                    for (var i = 0; i < self.options.marcadores.length; i++) {
                        if (self.options.marcadores[i].id == $("#destinoMAPA").val()) var id_dest = i;
                    }
                } else {
                    var id_dest = 0;
                }
                var destino = new google.maps.LatLng(self.options.marcadores[id_dest].lat, self.options.marcadores[id_dest].lng);

                if (origem != "") {
                    var request = {
                        origin: origem,
                        destination: destino,
                        travelMode: google.maps.DirectionsTravelMode.DRIVING
                    };

                    directionsService.route(request, function (response, status) {
                        if (status == google.maps.DirectionsStatus.OK) {

                            self._reset();

                            var legs = response.routes[0].legs;
                            var legsTam = legs.length;
                            var fim;
                            for (i = 0; i < legsTam; i++) {
                                var steps = legs[i].steps;
                                for (var step = 0; step < steps.length; step++) {
                                    polylineOptions = {
                                        map: map,
                                        strokeColor: self.options.rotaOptions.corlinha,
                                        strokeOpacity: .8,
                                        strokeWeight: 4,
										clickable:false,
                                        path: steps[step].lat_lngs
                                    }
                                    fim = steps[step].end_location;
                                    var linha = new google.maps.Polyline(polylineOptions);
                                    caminho.push(linha);
                                }

                                instrucoes = "";
                                instrucoes += "<div id='directions-topo-mapaMA'><img src='" + self.options.imgFolder + "/pin_origem.png' height=26 width=20 style='vertical-align:middle; padding-right:10px'/>" + legs[i].start_address + "</div>"
                                instrucoes += "<div id='directions-meio-mapaMA'>";

                                instrucoes += "<div class='d_linha header'>";
                                instrucoes += "<div class='d_id'>&nbsp;</div>";
                                instrucoes += "<div class='d_desc'>" + self.options.textos.infoTrajecto + " </div>";
                                instrucoes += "<div class='d_dist'><b>" + self.options.textos.distancia + ":</b> " + legs[i].distance.text + " <b>" + self.options.textos.duracao + ":</b> " + legs[i].duration.text + "</div>";
                                instrucoes += "</div>"



                                for (var k = 0; k < legs[i].steps.length; k++) {
                                    instrucoes += "<div class='d_linha'>";
                                    instrucoes += "<div class='d_id'>" + (k + 1) + "</div>";
                                    instrucoes += "<div class='d_desc'>" + legs[i].steps[k].instructions + "</div>";
                                    instrucoes += "<div class='d_dist'>" + legs[i].steps[k].distance.text + "</div>";
                                    instrucoes += "</div>"
                                }

                                instrucoes += "</div>";
                                instrucoes += "<div id='directions-fundo-mapaMA'><img src='" + self.options.imgFolder + "/pin_0.png' height=26 width=20 style='vertical-align:middle; padding-right:10px'/>" + legs[i].end_address + " - " + self.options.marcadores[id_dest].titulo + "</div>"
                            }

                            $("#" + self.options.directionsID + "").append(instrucoes);

                            $("#directions-topo-mapaMA").append('<div id="options-mapa-MA" style="cursor:pointer;cursor:hand;"></div<');

                            if (self.options.imprimir) {
                                $("#options-mapa-MA").append('<div id="options-mapa-print-MA"><img src="' + self.options.imgFolder + '/imprimir.png" style="vertical-align:middle; margin-top:8px; border:0" alt="" /></div>');
                            }

                            $("#options-mapa-MA").append('<div id="options-mapa-close-MA"><img src="' + self.options.imgFolder + '/fechar.png" style="vertical-align:middle; margin-top:8px; border:0" alt="" /></div>');

                            if (self.options.mapa) {
                                self._constroiMarcador(response.routes[0].legs[0].steps[0].start_location, self.options.textos.origem);
                                self._constroiMarcador(fim, self.options.marcadores[id_dest].titulo, 0);

                                map.fitBounds(limites);
                            }
                            $("#options-mapa-close-MA").show();
                            $("#options-mapa-print-MA").show();
                        } else {

                            if ($("#dir_erro").length == 0)
                                $("#" + self.options.directionsID + "").append('<div id="dir_erro" style="clear:both;padding-top:5px; padding-left:5px;padding-bottom:5px;">' + self.options.textos.naoencontrou + '</div>');
                            else
                                $("#dir_erro").html(self.options.textos.naoencontrou);



                        }
                    });
                }
                else {
                    alert('Campo de origem invlido.');
                }
            },
            //APAGA DETERMINADA ROTA DO MAPA
            apagaRota: function () {
                for (var c = 0; c < caminho.length; c++) {
                    caminho[c].setMap(null);
                }
                caminho = [];

                $("#" + this.options.directionsID + "").html("");
            },

            /********************* public functions *********************/
            refresh: function () {
                //reload with existing week
                // this._loadCalEvents(this.element.data('startDate'));
            },
            /*
             * Clear all events currently loaded into the calendar
             */
            clear: function () {
                //this._clearCalendar();
            }
        }; // end of widget function return
    })() //end of widget function closure execution
    ); // end of $.widget("ui.weekCalendar"...
})(jQuery);
